-- Name: EAS_PlaceableHusbandryAnimalsExtension
-- Author: Chissel

EAS_PlaceableHusbandryAnimalsExtension = {}

EAS_PlaceableHusbandryAnimalsExtension.NUM_BITS_eas_numOvercrowdingHours = 5

function EAS_PlaceableHusbandryAnimalsExtension.addAnimals(self, superFunc, subTypeIndex, numAnimals, age)
    local cluster = g_currentMission.animalSystem:createClusterFromSubTypeIndex(subTypeIndex)

    local subType = g_currentMission.animalSystem:getSubTypeByIndex(subTypeIndex)
    local neededAge = subType.reproductionMinAgeMonth + subType.reproductionDurationMonth

	if cluster:getSupportsMerging() then
		cluster.numAnimals = numAnimals
		cluster.age = age
		cluster.subTypeIndex = subTypeIndex

        if age >= neededAge then
            cluster.hadABirth = true
        end

		self:addCluster(cluster)
	else
		for i = 1, numAnimals do
			cluster = g_currentMission.animalSystem:createClusterFromSubTypeIndex(subTypeIndex)
			cluster.numAnimals = 1
			cluster.age = age

            if age >= neededAge then
                cluster.hadABirth = true
            end

			self:addCluster(cluster)
		end
	end
end

PlaceableHusbandryAnimals.addAnimals = Utils.overwrittenFunction(PlaceableHusbandryAnimals.addAnimals, EAS_PlaceableHusbandryAnimalsExtension.addAnimals)

function EAS_PlaceableHusbandryAnimalsExtension.onLoad(self, superFunc, savegame)
    superFunc(self, savegame)
    self.eas_numOvercrowdingHours = 0
end

PlaceableHusbandryAnimals.onLoad = Utils.overwrittenFunction(PlaceableHusbandryAnimals.onLoad, EAS_PlaceableHusbandryAnimalsExtension.onLoad)

function EAS_PlaceableHusbandryAnimalsExtension.saveToXMLFile(self, superFunc, xmlFile, key, usedModNames)
    superFunc(self, xmlFile, key, usedModNames)
	xmlFile:setInt(key .. "#eas_numOvercrowdingHours", self.eas_numOvercrowdingHours or 0)
end

PlaceableHusbandryAnimals.saveToXMLFile = Utils.overwrittenFunction(PlaceableHusbandryAnimals.saveToXMLFile, EAS_PlaceableHusbandryAnimalsExtension.saveToXMLFile)

function EAS_PlaceableHusbandryAnimalsExtension.loadFromXMLFile(self, superFunc, xmlFile, key)
    superFunc(self, xmlFile, key)
	self.eas_numOvercrowdingHours = xmlFile:getInt(key .. "#eas_numOvercrowdingHours", self.eas_numOvercrowdingHours or 0)
end

PlaceableHusbandryAnimals.loadFromXMLFile = Utils.overwrittenFunction(PlaceableHusbandryAnimals.loadFromXMLFile, EAS_PlaceableHusbandryAnimalsExtension.loadFromXMLFile)

function EAS_PlaceableHusbandryAnimalsExtension.onReadStream(self, superFunc, streamId, connection)
    superFunc(self, streamId, connection)
	self.eas_numOvercrowdingHours = streamReadUIntN(streamId, EAS_PlaceableHusbandryAnimalsExtension.NUM_BITS_eas_numOvercrowdingHours)
end

PlaceableHusbandryAnimals.onReadStream = Utils.overwrittenFunction(PlaceableHusbandryAnimals.onReadStream, EAS_PlaceableHusbandryAnimalsExtension.onReadStream)

function EAS_PlaceableHusbandryAnimalsExtension.onWriteStream(self, superFunc, streamId, connection)
    superFunc(self, streamId, connection)
	streamWriteUIntN(streamId, self.eas_numOvercrowdingHours or 0, EAS_PlaceableHusbandryAnimalsExtension.NUM_BITS_eas_numOvercrowdingHours)
end

PlaceableHusbandryAnimals.onWriteStream = Utils.overwrittenFunction(PlaceableHusbandryAnimals.onWriteStream, EAS_PlaceableHusbandryAnimalsExtension.onWriteStream)

function EAS_PlaceableHusbandryAnimalsExtension.onReadUpdateStream(self, superFunc, streamId, connection)
    superFunc(self, streamId, connection)
	self.eas_numOvercrowdingHours = streamReadUIntN(streamId, EAS_PlaceableHusbandryAnimalsExtension.NUM_BITS_eas_numOvercrowdingHours)
end

PlaceableHusbandryAnimals.onReadUpdateStream = Utils.overwrittenFunction(PlaceableHusbandryAnimals.onReadUpdateStream, EAS_PlaceableHusbandryAnimalsExtension.onReadUpdateStream)

function EAS_PlaceableHusbandryAnimalsExtension.onWriteUpdateStream(self, superFunc, streamId, connection)
	superFunc(self, streamId, connection)
    streamWriteUIntN(streamId, self.eas_numOvercrowdingHours or 0, EAS_PlaceableHusbandryAnimalsExtension.NUM_BITS_eas_numOvercrowdingHours)
end

PlaceableHusbandryAnimals.onWriteUpdateStream = Utils.overwrittenFunction(PlaceableHusbandryAnimals.onWriteUpdateStream, EAS_PlaceableHusbandryAnimalsExtension.onWriteUpdateStream)