-- Name: EAS_InseminateClusterEvent
-- Author: Chissel

EAS_InseminateClusterEvent = {}

local EAS_InseminateClusterEvent_mt = Class(EAS_InseminateClusterEvent, Event)
InitEventClass(EAS_InseminateClusterEvent, "EAS_InseminateClusterEvent")

function EAS_InseminateClusterEvent.emptyNew()
    local self = Event.new(EAS_InseminateClusterEvent_mt)

    return self
end

function EAS_InseminateClusterEvent.new(husbandry, clusterId)
    local self = EAS_InseminateClusterEvent.emptyNew()

    self.husbandry = husbandry
    self.clusterId = clusterId

    return self
end

function EAS_InseminateClusterEvent:readStream(streamId, connection)
    g_easUtils:logText("EAS_InseminateClusterEvent readStream")
    self.husbandry = NetworkUtil.readNodeObject(streamId)
    self.clusterId = streamReadInt32(streamId)

    self:run(connection)
end

function EAS_InseminateClusterEvent:writeStream(streamId, connection)
    g_easUtils:logText("EAS_InseminateClusterEvent writeStream")
    NetworkUtil.writeNodeObject(streamId, self.husbandry)
    streamWriteInt32(streamId, self.clusterId)
end

function EAS_InseminateClusterEvent:run(connection)
    local clusterSystem = self.husbandry.spec_husbandryAnimals.clusterSystem
    local cluster = clusterSystem:getClusterById(self.clusterId)
    cluster.isInseminated = true

    if not connection:getIsServer() then
        g_server:broadcastEvent(EAS_InseminateClusterEvent.new(self.husbandry, self.clusterId), false)
    end
end